## seqan-needle 1.0.1.0.0.git.3011926%2Bds

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,dversionmangle=auto,repacksuffix=+ds" \
  https://github.com/seqan/needle/tags (?:.*?/)?needle-v?@ANY_VERSION@@ARCHIVE_EXT@
