=== debian/changelog ===
seqan-needle (1.0.1.0.0.git.3011926+ds-4) unstable; urgency=medium

  * Team upload.
  * Create doc without previous binary build
    Closes: #1024458

 -- Andreas Tille <tille@debian.org>  Thu, 24 Nov 2022 11:38:47 +0100

seqan-needle (1.0.1.0.0.git.3011926+ds-3) unstable; urgency=medium

  * Team Upload.
  * Really move needle to usr/lib/debian-med/bin (Closes: #1023807)
  * d/rules: Fix arch:all build (Closes: #1024458)
  * Disable i386 in salsa-ci.yml since seqan-needle does not build on 32-bit

 -- Nilesh Patra <nilesh@debian.org>  Tue, 22 Nov 2022 19:54:37 +0530

seqan-needle (1.0.1.0.0.git.3011926+ds-2) unstable; urgency=medium

  * Rename binary to seqan-needle, add symlink and README.Debian
    Closes: #1023807

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 16 Nov 2022 17:00:44 +0100

seqan-needle (1.0.1.0.0.git.3011926+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1023322)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Oct 2022 18:58:32 +0200
