=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	rm -Rf lib/seqan3
	dh_auto_configure -- -DSEQAN3_NO_LEMON=OFF

override_dh_auto_build-arch:
	dh_auto_build --arch
	obj-*/bin/needle --export-help man > debian/needle.1
	obj-*/bin/needle count --export-help man > debian/needle-count.1
	obj-*/bin/needle estimate --export-help man > debian/needle-estimate.1
	obj-*/bin/needle ibf --export-help man > debian/needle-ibf.1
	obj-*/bin/needle minimiser --export-help man > debian/needle-minimiser.1

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	doxygen doc/doxygen_cfg
endif

override_dh_auto_test-indep:
	echo "Do Nothing"
