=== debian/changelog ===
seqan-needle (1.0.1.0.1.git.439eeab+ds-1) unstable; urgency=medium

  * New upstream snapshot with gcc-12 compatibility Closes: #1037855
  * d/patches: refresh; drop spelling patch (applied upstream).
  * d/patches: cherry-pick from upstream for Seqan 3.3.0
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Bug-Submit.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Aug 2023 17:41:39 +0200
