## seqan-needle 1.0.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,3 +47,19 @@
 
 enable_testing ()
 add_subdirectory (test EXCLUDE_FROM_ALL)
+
+set (CPACK_GENERATOR "TXZ")
+
+set (CPACK_PACKAGE_VERSION "1.0.2")
+set (CPACK_PACKAGE_VENDOR "seqan")
+# A description of the project, used in places such as the introduction screen of CPack-generated Windows installers.
+# set (CPACK_PACKAGE_DESCRIPTION_FILE "") # TODO
+set (CPACK_PACKAGE_CHECKSUM "SHA256")
+set (CPACK_RESOURCE_FILE_LICENSE "${needle_SOURCE_DIR}/LICENSE.md")
+set (CPACK_RESOURCE_FILE_README "${needle_SOURCE_DIR}/README.md")
+
+# Source Package
+set (CPACK_SOURCE_GENERATOR "TXZ")
+set (CPACK_SOURCE_IGNORE_FILES "\\\\.git($|/)")
+
+include (CPack)
