=== test/api/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 # The api_test build target.
 add_api_test (count_test.cpp)
+add_api_test (insert_delete_test.cpp)
 add_api_test (estimate_test.cpp)
 add_api_test (ibf_test.cpp)
 add_api_test (ibfmin_test.cpp)
