=== test/cli/CMakeLists.txt ===
--- 
+++ 
@@ -12,3 +12,4 @@
 add_cli_test (count_options_test.cpp)
 target_use_datasources (count_options_test FILES mini_example.fasta mini_gen.fasta mini_gen.genome)
 add_cli_test (delete_options_test.cpp)
+target_use_datasources (delete_options_test FILES exp_01.fasta)
