=== debian/changelog ===
seqan-needle (1.0.2+ds-2) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * d/clean: remove HTML build of the documentation. Closes: #1048377
  * corrected some patch metadata.

  [ Komolehin Israel Timilehin ]
  * Added Autopkgtest

 -- Komolehin Israel Timilehin <komolehinisrael@gmail.com>  Mon, 08 Jan 2024 11:38:37 +0100

seqan-needle (1.0.2+ds-1) unstable; urgency=medium

  * d/watch: find the complete source archives
  * New upstream version
  * d/rules: set "-O3" to match a normal release build.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 04 Sep 2023 17:57:09 +0200
