=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libcereal-dev,
                pkg-config,
                doxygen <!nodoc>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/seqan-needle
 Vcs-Git: https://salsa.debian.org/med-team/seqan-needle.git
 Homepage: https://github.com/seqan/needle
