=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 # DH_VERBOSE := 1
 export LC_ALL=C.UTF-8
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+export DEB_CFLAGS_MAINT_APPEND=-O3
+export DEB_CXXFLAGS_MAINT_APPEND=-O3
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
