=== debian/changelog ===
seqan-needle (1.0.3~rc.2+ds-2) unstable; urgency=medium

  * Fix arch: all build
  * d/control: Restrict to 64-bit little-endian systems.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 09 Nov 2024 16:29:51 +0100

seqan-needle (1.0.3~rc.2+ds-1) unstable; urgency=medium

  * d/watch: rewrite RC versions to Debian style
  * d/copyright: match new layout
  * New upstream version. Closes: #1086625
  * Drop a patch applied upstream, and another that is no longer needed.
  * d/rules: use CPM_USE_LOCAL_PACKAGES=On
  * d/seqan-needle.install: update path
  * Added patch to find and use libseqan3-dev
  * Autopkgtests: build and run agains the installed needle binary.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 07 Nov 2024 17:28:29 +0100
