=== debian/control ===
--- 
+++ 
@@ -4,11 +4,14 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
+               architecture-is-little-endian,
                cmake,
                libseqan3-dev (>= 3.2.0+ds-5),
                libgtest-dev,
                libcereal-dev,
                pkg-config,
+               git,
                doxygen <!nodoc>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/seqan-needle
