=== debian/rules ===
--- 
+++ 
@@ -11,17 +11,21 @@
 %:
 	dh $@
 
-override_dh_auto_configure:
-	rm -Rf lib/seqan3
-	dh_auto_configure -- -DSEQAN3_NO_LEMON=OFF
+override_dh_auto_configure-indep:
+	echo I: No configuration needed for the docs
 
-override_dh_auto_build-arch:
-	dh_auto_build --arch
+override_dh_auto_configure-arch:
+	dh_auto_configure --arch -- -DSEQAN3_NO_LEMON=OFF -DCPM_USE_LOCAL_PACKAGES=On
+
+execute_after_dh_auto_build-arch:
 	obj-*/bin/needle --export-help man > debian/needle.1
 	obj-*/bin/needle count --export-help man > debian/needle-count.1
 	obj-*/bin/needle estimate --export-help man > debian/needle-estimate.1
 	obj-*/bin/needle ibf --export-help man > debian/needle-ibf.1
 	obj-*/bin/needle minimiser --export-help man > debian/needle-minimiser.1
+
+execute_after_dh_auto_test:
+	rm -Rf obj-*/test
 
 override_dh_auto_build-indep:
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
@@ -29,4 +33,4 @@
 endif
 
 override_dh_auto_test-indep:
-	echo "Do Nothing"
+	echo I: Not running tests for the docs
