## seqan-needle 1.0.3%2Bds

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
-cmake_minimum_required (VERSION 3.9)
+# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
+# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
+# SPDX-License-Identifier: BSD-3-Clause
+
+cmake_minimum_required (VERSION 3.25...3.30)
 
 # Find doxygen.
 find_package (Doxygen 1.9.4 QUIET)
@@ -8,7 +12,7 @@
 
     # Configure doxygen options.
     set (APP_TEMPLATE_DOXYFILE_IN ${CMAKE_SOURCE_DIR}/doc/doxygen_cfg)
-    set (APP_TEMPLATE_DOXYGEN_OUTPUT_DIR "${PROJECT_BINARY_DIR}/doc")
+    set (APP_TEMPLATE_DOXYGEN_OUTPUT_DIR "${PROJECT_BINARY_DIR}")
     set (APP_TEMPLATE_DOXYGEN_EXCLUDE_SYMBOLS "")
     set (APP_TEMPLATE_DOXYGEN_PREDEFINED_NDEBUG "")
     set (APP_TEMPLATE_DOXYGEN_ENABLED_SECTIONS "DEV")
@@ -19,7 +23,8 @@
                        COMMAND ${DOXYGEN_EXECUTABLE}
                        WORKING_DIRECTORY ${APP_TEMPLATE_DOXYGEN_OUTPUT_DIR}
                        COMMENT "Generating (developer) API documentation with Doxygen."
-                       VERBATIM)
+                       VERBATIM
+    )
     message (STATUS "${FontBold}You can run `make doc` to build api documentation.${FontReset}")
 else ()
     message (STATUS "Doxygen not found.")
