=== test/api/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

add_app_test (count_test.cpp)
add_app_test (insert_delete_test.cpp)
add_app_test (estimate_test.cpp)
add_app_test (ibf_test.cpp)
add_app_test (ibfmin_test.cpp)
add_app_test (minimiser_test.cpp)
